#ifndef __DEBUG_H
#define __DEBUG_H

extern int trace_level;

enum {
	TRACE_ERR = 1,
	TRACE_WARN,
	TRACE_INFO,
	TRACE_DEBUG,
	TRACE_MAX,
};

void  __attribute__ ((__format__ (__printf__, 4, 5)))
print_trace(const char *file, int line, int l,
		const char *fmt, ...);

#define pr_err(arg...)   print_trace(__FILE__, __LINE__, TRACE_ERR, arg)
#define pr_warn(arg...)  print_trace(__FILE__, __LINE__, TRACE_WARN, arg)
#define pr_info(arg...)  print_trace(__FILE__, __LINE__, TRACE_INFO, arg)
#define pr_debug(arg...) print_trace(__FILE__, __LINE__, TRACE_DEBUG, arg)

#endif
